#define SIZE 800

static int isbad(char *text, struct Channel *chptr);

extern BlockHeap *badword_heap;

static
char *mystrcasestr (char *big, char *little)
{
  char bigbuf[SIZE];
  char littlebuf[SIZE];

  if((big == NULL) || (little == NULL))
    return NULL;

  if(*little == '\0')
    return big;

  strlcpy(bigbuf, big, SIZE);
  strlcpy(littlebuf, little, SIZE);

  {
    char *t = bigbuf;
    while ((*t++ = tolower(*t)))
     ;
  }
  {
    char *t = littlebuf;
    while ((*t++ = tolower(*t)))
      ;
  }

  return ( strstr(bigbuf, littlebuf) );
}

static int isbad (char *text, struct Channel *chptr)
{
  dlink_node *ptr;
  dlink_node *tptr;
  struct BadWords *badwords;

  DLINK_FOREACH_SAFE(ptr, tptr, chptr->badwordlist.head)
  {
    if (!ConfigChannel.use_badwords)
      return 0;

    badwords = ptr->data;

    if (mystrcasestr(text, badwords->word))
      return 1;
  }

  return 0;
}
