/*
 *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
 *  m_away.c: Negotiates capabilities with a remote server.
 *
 *  Copyright (C) 2002 by the past and present ircd coders, and others.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  $Id: ipmask.c,v 1.4 2002/11/18 13:03:33 jeremy Exp $
 */

#include "stdinc.h"
#include "tools.h"
#include "s_user.h"
#include "channel.h"
#include "channel_mode.h"
#include "class.h"
#include "client.h"
#include "common.h"
#include "fdlist.h"
#include "hash.h"
#include "irc_string.h"
#include "sprintf_irc.h"
#include "ircd.h"
#include "listener.h"
#include "motd.h"
#include "ircd_handler.h"
#include "msg.h"
#include "numeric.h"
#include "s_bsd.h"
#include "s_conf.h"
#include "s_log.h"
#include "s_serv.h"
#include "s_stats.h"
#include "scache.h"
#include "send.h"
#include "supported.h"
#include "whowas.h"
#include "md5.h"
#include "memory.h"
#include "packet.h"

void maskip(struct Client *);

void maskip(struct Client *client_p)
{
	char buf[HOSTLEN];
	int i = 0,j = 0;
	char *tmp = NULL;
	char *tmp2 = NULL;
	char *tmp3 = NULL;
	char *tmp4 = NULL;
	char mask[HOSTLEN];

	strlcpy(buf, client_p->realhost, HOSTLEN);
	j = strlen(buf);

	if(strchr(buf, '.'))
	{
		if(!isdigit(buf[j - 1]))
		{
			tmp = strchr(buf, '.');
			*tmp = '\0';
			tmp++;
			tmp2 = strchr(tmp, '.');

			if(tmp2 != NULL)
				ircsprintf(mask, "%s-%d.%s", ServerInfo.network_name, rand() % 100000, tmp);

		}
		else
		{
			tmp = strrchr(buf, '.');
			*tmp = '\0';
			tmp--;

			ircsprintf(mask, "%s.%d", buf, rand() % 100000);
		}

		if(mask != NULL)
			strlcpy(client_p->host, mask, HOSTLEN);
	}


#ifdef IPV6
	if(strchr(buf, ':'))
	{
		tmp = strrchr(buf, ':');
		*tmp = '\0';
		tmp--;
		tmp2 = strrchr(tmp, ':');

		if(tmp2 != NULL)
		{
			tmp3 = strrchr(tmp2, ':');

			if(tmp3 != NULL)
			{
				tmp4 = strrchr(tmp3, ':');
				*tmp4 = '\0';
				tmp4--;
			}
			ircsprintf(mask, "%s::IPV6", buf);
		}

		if(mask != NULL)
			strlcpy(client_p->host, mask, HOSTLEN);
	}
#endif
}
